"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clearAnimationFrameTimeout = exports.setAnimationFrameTimeout = void 0;
function setAnimationFrameTimeout(callback, timeout = 0) {
    const startTime = performance.now();
    const canceller = {};
    function call() {
        canceller.id = requestAnimationFrame((now) => {
            if (now - startTime > timeout) {
                callback();
            }
            else {
                call();
            }
        });
    }
    call();
    return canceller;
}
exports.setAnimationFrameTimeout = setAnimationFrameTimeout;
function clearAnimationFrameTimeout(canceller) {
    if (canceller.id)
        cancelAnimationFrame(canceller.id);
}
exports.clearAnimationFrameTimeout = clearAnimationFrameTimeout;
//# sourceMappingURL=setAnimationFrameTimeout.js.map