"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSwitchTransition = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const useDefaultMode_1 = require("./useDefaultMode");
const useInOutMode_1 = require("./useInOutMode");
const useOutInMode_1 = require("./useOutInMode");
function useSwitchTransition(state, timeout, mode) {
    const keyRef = (0, react_1.useRef)(0);
    const firstDefaultItem = {
        state,
        key: keyRef.current,
        stage: 'enter',
    };
    const [list, setList] = (0, react_1.useState)([firstDefaultItem]);
    // for default mode only
    (0, useDefaultMode_1.useDefaultMode)({ state, timeout, keyRef, mode, list, setList });
    // for out-in mode only
    (0, useOutInMode_1.useOutInMode)({ state, timeout, keyRef, mode, list, setList });
    // for in-out mode only
    (0, useInOutMode_1.useInOutMode)({ state, timeout, keyRef, mode, list, setList });
    function transition(renderCallback) {
        return list.map((item) => ((0, jsx_runtime_1.jsx)(react_1.Fragment, { children: renderCallback(item.state, item.stage) }, item.key)));
    }
    return transition;
}
exports.useSwitchTransition = useSwitchTransition;
//# sourceMappingURL=index.js.map