"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useOutInMode = void 0;
const react_1 = require("react");
const setAnimationFrameTimeout_1 = require("../helpers/setAnimationFrameTimeout");
function useOutInMode({ state, timeout, mode, keyRef, list, setList, }) {
    const timerRef = (0, react_1.useRef)({});
    (0, react_1.useEffect)(() => {
        // skip unmatched mode 🚫
        if (mode !== 'out-in')
            return;
        const [lastItem] = list.slice(-1);
        // if state has changed && stage is enter (trigger prev last item to leave)
        if (lastItem.state !== state && lastItem.stage === 'enter') {
            // 1 leave prev last item
            setList([Object.assign(Object.assign({}, lastItem), { stage: 'leave' })]);
        }
        // if state has changed && stage is leave (add new item after prev last item leave ani ends)
        if (lastItem.state !== state && lastItem.stage === 'leave') {
            // 2 add new item after prev last item leave animation ends
            (0, setAnimationFrameTimeout_1.clearAnimationFrameTimeout)(timerRef.current);
            timerRef.current = (0, setAnimationFrameTimeout_1.setAnimationFrameTimeout)(() => {
                keyRef.current++;
                setList([{ state, key: keyRef.current, stage: 'from' }]);
            }, timeout);
        }
        // if state hasn't change && stage is from
        if (lastItem.state === state && lastItem.stage === 'from') {
            // 3 change that new item's stage to 'enter' immediately
            (0, setAnimationFrameTimeout_1.setAnimationFrameTimeout)(() => {
                setList((prev) => [Object.assign(Object.assign({}, prev[0]), { stage: 'enter' })]);
            });
        }
        return () => (0, setAnimationFrameTimeout_1.clearAnimationFrameTimeout)(timerRef.current);
    }, [keyRef, list, mode, setList, state, timeout]);
}
exports.useOutInMode = useOutInMode;
//# sourceMappingURL=useOutInMode.js.map