"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useTransition = void 0;
const react_1 = require("react");
const setAnimationFrameTimeout_1 = require("../helpers/setAnimationFrameTimeout");
function useTransition(state, timeout) {
    // the stage of transition - 'from' | 'enter' | 'leave'
    const [stage, setStage] = (0, react_1.useState)(state ? 'enter' : 'from');
    // the timer for should mount
    const timer = (0, react_1.useRef)({});
    const [shouldMount, setShouldMount] = (0, react_1.useState)(state);
    (0, react_1.useEffect)(function handleStateChange() {
        (0, setAnimationFrameTimeout_1.clearAnimationFrameTimeout)(timer.current);
        // when true - trans from to enter
        // when false - trans enter to leave, unmount after timeout
        if (state === true) {
            setStage('from');
            setShouldMount(true);
            (0, setAnimationFrameTimeout_1.setAnimationFrameTimeout)(() => {
                setStage('enter');
            });
        }
        else {
            setStage('leave');
            timer.current = (0, setAnimationFrameTimeout_1.setAnimationFrameTimeout)(() => {
                setShouldMount(false);
            }, timeout);
        }
        return () => (0, setAnimationFrameTimeout_1.clearAnimationFrameTimeout)(timer.current);
    }, [state, timeout]);
    return {
        stage,
        shouldMount,
    };
}
exports.useTransition = useTransition;
//# sourceMappingURL=index.js.map